searchNodes=[{"doc":"Griffin is a Static Site Generator. Griffin reads Markdown files from disk and outputs HTML pages. A combination of Application level config, frontmatter attributes and layout files can be used to customize the output of each file and to build the page structure of the website. Each input file can have a first segment called &quot;front matter&quot; that lists metadata about the file contents. This front matter segment is delineated by a sequence of characters --- and the contents should be in YAML format. The contents that follow can contain plain content or reference front matter attributes. Here is an example of a short Markdown file with some front matter attributes: -- - title : &quot;Griffin Static Site Generator&quot; draft : true -- - # Griffin Static Site Generator Griffin is an Elixir framework for building static websites .","ref":"GriffinSSG.html","title":"GriffinSSG","type":"module"},{"doc":"Parses the string contents of a file into two components: front matter and file content. Front matter is optional metadata about the content that is defined at the top of the file. The content immediately follows the front matter and may reference front matter variables. Returns a map with both the front matter and file content.","ref":"GriffinSSG.html#parse/1","title":"GriffinSSG.parse/1","type":"function"},{"doc":"Renders a layout with a given content, front matter and assigns. The layout is assumed to be a compiled EEx file or string, such that calling Code.eval_quoted/2 on the layout will generate a correct result.","ref":"GriffinSSG.html#render/2","title":"GriffinSSG.render/2","type":"function"},{"doc":"&lt;%= @app_module %&gt; Cowboy Plug to serve files from the output directory WARNING: This is a simple webserver written only to serve files from disk. It is meant only for usage in development environments. Please do not use this as a means to serve your generated website.","ref":"GriffinSSG.Web.Plug.html","title":"GriffinSSG.Web.Plug","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"GriffinSSG.Web.Plug.html#call/2","title":"GriffinSSG.Web.Plug.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"GriffinSSG.Web.Plug.html#init/1","title":"GriffinSSG.Web.Plug.init/1","type":"function"},{"doc":"","ref":"GriffinSSG.Web.Plug.html#not_found/2","title":"GriffinSSG.Web.Plug.not_found/2","type":"function"},{"doc":"","ref":"GriffinSSGApp.html","title":"GriffinSSGApp","type":"module"},{"doc":"This is the documentation for the Griffin project. By default, Griffin will scan for content in the priv/content directory and output generated files to the _site directory. Griffin depends on the following libraries: Plug - a specification and conveniences for composable modules in between web applications","ref":"GriffinSSGOld.html","title":"GriffinSSGOld","type":"module"},{"doc":"Compiles a template file from disk into quoted code that can then be used by GriffinSSG.render/3 .","ref":"GriffinSSGOld.html#compile_layout/2","title":"GriffinSSGOld.compile_layout/2","type":"function"},{"doc":"Reads a file from disk and returns the parsed frontmatter metadata and the file contents.","ref":"GriffinSSGOld.html#parse_file/2","title":"GriffinSSGOld.parse_file/2","type":"function"},{"doc":"Renders a layout to file, taking in a number of options that affect the rendered output. The following options are accepted: frontmatter - the frontmatter attributes content - the content to render in the layout assigns - a map with template variables to be used in the layout","ref":"GriffinSSGOld.html#render/3","title":"GriffinSSGOld.render/3","type":"function"},{"doc":"Generates a Griffin static site from existing template files $ mix grf.build A set of files will be written to the configured output directory, _site by default","ref":"Mix.Tasks.Grf.Build.html","title":"Mix.Tasks.Grf.Build","type":"task"},{"doc":"Generates a new Markdown page with relevant front matter attributes. $ mix grf.gen.page PATH [--title TITLE] A Markdown file will be created with the name at the specified path with the default metadata fields: title , date and draft . Options --title - the page title. Defaults to _site","ref":"Mix.Tasks.Grf.New.Page.html","title":"Mix.Tasks.Grf.New.Page","type":"task"},{"doc":"Starts the application by configuring all endpoints servers to run. Note: to start the endpoint without using this mix task you must set server: true in your Phoenix.Endpoint configuration. Command line options --open - open browser window for each started endpoint Furthermore, this task accepts the same command-line options as mix run . For example, to run phx.server without recompiling: $ mix phx.server --no-compile The --no-halt flag is automatically added. Note that the --no-deps-check flag cannot be used this way, because Mix needs to check dependencies to find phx.server . To run phx.server without checking dependencies, you can run: $ mix do deps.loadpaths --no-deps-check, phx.server","ref":"Mix.Tasks.Grf.Server.html","title":"Mix.Tasks.Grf.Server","type":"task"},{"doc":"Griffin takes advantage of all of your CPU-cores to generate static websites quickly. It aims to be the Elixir alternative to popular generators like 11ty or hugo . Griffin was made to feel familiar to Elixir developers. It uses the same mix based installer as Phoenix , which will make Elixir web developers feel right at home. Griffin is not competing with Phoenix. Griffin was created to make it easier to build static websites, where none of Phoenix's flagship features are relevant. Griffin uses independent template languages. Despite being an Elixir tool, content is written in Markdown with YAML front matter to allow easier migrations to or from Griffin. Griffin is simple to use. We lower the barrier to entry by using sensible defaults and minimizing the amount of configuration needed to set up a Griffin website. Griffin is built by the community. This is a new project that is still in active development. Feel free to engage with us by starring the project on Github , contributing a pull-request or helping answer questions, making sure to follow our code of conduct . Keep going! Next up, read Getting Started","ref":"overview.html","title":"Griffin is an Elixir static site generator","type":"extras"},{"doc":"This page provides two lists of terms — one for Griffin-specific terminology that may be useful for when building out a project using Griffin, and one for industry jargon that may be useful for understanding context.","ref":"glossary.html","title":"Glossary","type":"extras"},{"doc":"Template A content file written in a format such as Markdown, HTML, HEEx or Liquid, which Griffin transforms into one or more pages in the built site. Templates can access data exposed through the data cascade with templating syntax. Layout A template which wraps around another template, typically to provide the scaffolding markup for content to sit in. Read more about using layouts. Data Exposed via variables that can be used inside templates and layouts using templating syntax. The data for a given template is aggregated through a process called the data cascade . Data Cascade Griffin's order of operations for evaluating all data for any given template , and for resolving conflicts that arise. The data cascade follows the principle of colocation, so data defined broadly to apply to many templates will be overruled by data that targets the given template more specifically. Collection An array of templates , used to group similar content. Collections can be created by using tags or by calling the collections API in the Griffin configuration . Read more about collections.","ref":"glossary.html#griffin-specific-terminology","title":"Glossary - Griffin-Specific Terminology","type":"extras"},{"doc":"Our industry can be particularly bad about inventing words for things that already exist. Hopefully this page will help you navigate the labyrinth. Static Sites A static site is a group of generated HTML files. Content is built into the HTML files rather than using a dynamic back end language to generate the content on-the-fly. A dynamic site can appear static when you add caching rules to make the content stickier. A static site can appear dynamic when you run your build quickly and often. Data-Driven Make components and markup data-driven so that you don’t have a bunch of one-off copy-pasted HTML instances littered throughout your project. Zero Config Zero config means that Griffin can run without any command line parameters or configuration files. We’ve taken care to setup Griffin so that that running the stock grf.build command uses sensible defaults. Lower the barrier to entry for that first project build to get up and running faster. Convention over Configuration Routing Instead of requiring a centralized configuration file for routing, Griffin routes map the file system, unless you override with a permalink .","ref":"glossary.html#industry-terms-and-buzzwords","title":"Glossary - Industry Terms and Buzzwords","type":"extras"},{"doc":"Griffin requires Elixir version 1.14 or higher. You can check if you have Elixir installed by running iex --version from a terminal. If the command is not found, you will need to download and install Elixir before moving on.","ref":"getting_started.html","title":"Getting Started","type":"extras"},{"doc":"Create a new project using mix new : mix new blog Now move into that directory with the cd command: cd blog","ref":"getting_started.html#1-create-a-new-elixir-project","title":"Getting Started - 1. Create a new Elixir project","type":"extras"},{"doc":"Edit the mix.exs file to include griffin_ssg as part of your dependencies: defp deps do [ # add the following line # to your list of dependencies { :griffin_ssg , &quot;~&gt; 0,2&quot; } , ] end Fetch and install Griffin Run mix deps.get to fetch and install Griffin.","ref":"getting_started.html#2-add-griffin-as-a-dependency","title":"Getting Started - 2. Add Griffin as a dependency","type":"extras"},{"doc":"Let's use one of Griffin's scripts to test that the installation is working: mix grf.build Here's what the terminal might look like after you've run this command: ~/blog $ mix grf.build Wrote 0 files in 0.03 seconds (v0.2.0) If you see (v0.2.0) that means you're running the latest version of Griffin. Note that Griffin didn't process any files -- this was expected, since we've not added templates yet.","ref":"getting_started.html#3-run-griffin","title":"Getting Started - 3. Run Griffin","type":"extras"},{"doc":"A template is a content file written in a format such as Markdown, HTML or Liquid, which Griffin transforms into one or more pages when building our website. Let's create a couple of templates with the following commands: echo &#39;&lt;!doctype html&gt;&lt;title&gt;My Cool Blog&lt;/title&gt;&lt;p&gt;Hello!&lt;/p&gt;&#39; &gt; index.html echo &#39;# Hello From Griffin&#39; &gt; README.md You can create these template files manually with any editor you like, just make sure to save them in your project folder and to use the right file extensions. Now that we have an HTML and a Markdown template, let's run Griffin again: mix grf.build The output may look like this: ~/blog $ mix grf.build Writing _site/README/index.html from ./README.md (liquid) Writing _site/index.html from ./index.html (liquid) Wrote 2 files in 0.06 seconds (v0.2.0) We’ve compiled our two content templates in the current directory into the output folder ( _site is the default).","ref":"getting_started.html#4-create-some-templates","title":"Getting Started - 4. Create some templates","type":"extras"},{"doc":"Let's use a different Griffin script to spin up a local HTTP server: mix grf.server Open http://localhost:4000/ or http://localhost:4000/README/ in your favorite web browser to see your Griffin site live! At the moment you still need to re-run mix grf.build every time you make changes to the templates, but we'll add a hot-reloading feature in an upcoming version.","ref":"getting_started.html#5-see-the-results","title":"Getting Started - 5. See the results","type":"extras"},{"doc":"Copying files using passthrough In your config.exs file, you can add a list of files or directories to be copied over to the output directory using the passthrough_copies configuration key: config :griffin_ssg , passthrough_copies : [ &quot;styles.css&quot; , &quot;bundle.js&quot; ] Then in your HTML you can reference these files: &lt;html&gt; &lt;head&gt; &lt;link rel=&quot;stylesheet&quot; href=&quot;/bundle.css&quot;&gt; &lt;script src=&quot;/bundle.js&quot;&gt;&lt;/script&gt; &lt;/head&gt; &lt;!-- rest of the page --&gt; &lt;/html&gt;","ref":"adding_js_css_fonts.html","title":"Adding JS, CSS and Fonts","type":"extras"},{"doc":"Layouts are special templates that can be used to wrap other content. To denote that a piece of content should be wrapped in a template, use the layout key in your front matter, like so: --- layout: cool_layout.eex title: My Cool Griffin Blog Post --- # &lt;%= title %&gt; This will look for a cool_layout.eex EEx file in your includes folder at _includes/cool_layout.eex . Next, we need to create a cool_layout.eex file. It can contain any type of text, but here we’re using HTML: --- title: My Griffin Blog --- &lt;!doctype html&gt; &lt;html lang=&quot;en&quot;&gt; &lt;head&gt; &lt;meta charset=&quot;utf-8&quot;&gt; &lt;meta name=&quot;viewport&quot; content=&quot;width=device-width, initial-scale=1.0&quot;&gt; &lt;title&gt;&lt;%= @title %&gt;&lt;/title&gt; &lt;/head&gt; &lt;body&gt; &lt;%= @content %&gt; &lt;/body&gt; &lt;/html&gt; Note that the layout template will populate the @content data with the child template’s content. Layouts can contain their own front matter data! It’ll be merged with the content’s data on render. Content data takes precedence, if conflicting keys arise. Read more about how Griffin merges data in what we call the Data Cascade . All of this will output the following HTML content to _site/some-page/index.html : &lt;!doctype html&gt; &lt;html lang=&quot;en&quot;&gt; &lt;head&gt; &lt;meta charset=&quot;utf-8&quot;&gt; &lt;meta name=&quot;viewport&quot; content=&quot;width=device-width, initial-scale=1.0&quot;&gt; &lt;title&gt;My Cool Griffin Blog Post&lt;/title&gt; &lt;/head&gt; &lt;body&gt; &lt;h1&gt;My Cool Griffin Blog Post&lt;/h1&gt; &lt;/body&gt; &lt;/html&gt; Front matter data in layouts In Griffin's Data Cascade , front matter data in your template is merged with Layout front matter data! All data is merged ahead of time so that you can mix and match variables in your content and layout templates interchangeably. Front matter data set in a content template takes priority over layout front matter! The closer to the content, the higher priority the data. Sources of data When the data is merged in the Data Cascade , the order of priority for sources of data is (from highest priority to lowest): Computed Data Front Matter Data in a Template Template Data Files Directory Data Files Front Matter Data in Layouts Configuration Global Data Global Data Files Layout aliasing In your config.exs configuration file, you can a mapping of aliases for layouts using the layout_aliases configuration key: config :griffin_ssg , layout_aliases : %{ post : &quot;cool_layout.eex&quot; }","ref":"layouts.html","title":"Layouts","type":"extras"},{"doc":"Documentation to be added.","ref":"collections.html","title":"Collections","type":"extras"},{"doc":"Documentation to be added.","ref":"pagination.html","title":"Pagination","type":"extras"},{"doc":"Documentation to be added.","ref":"permalinks.html","title":"Permalinks","type":"extras"}]